﻿// Downloaded from ThorProjects.com Copyright 2010 AvailTek LLC
// Use of this file is granted to all parties so long as this notice stays intact.
using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint.Workflow;

namespace WorkflowTools.Activities
{
    public partial class OnItemChangedActivity : SequenceActivity
    {
        public OnItemChangedActivity()
        {
            InitializeComponent();
        }

        private HandleExternalEventActivity ItemChangedEvent;
        private CallExternalMethodActivity subscribeOnItemChanged;
        public static DependencyProperty WorkflowPropertiesProperty = DependencyProperty.Register("WorkflowProperties", typeof(SPWorkflowActivationProperties),
            typeof(OnItemChangedActivity));
        public static DependencyProperty SubscriptionIdProperty = DependencyProperty.Register("SubscriptionId", typeof(System.Guid), typeof(OnItemChangedActivity));
        public static DependencyProperty ItemIdProperty = DependencyProperty.Register("ItemId", typeof(System.Int32), typeof(OnItemChangedActivity));
        public static DependencyProperty ListIdProperty = DependencyProperty.Register("ListId", typeof(System.Guid), typeof(OnItemChangedActivity));

        public SPWorkflowActivationProperties WorkflowProperties
        {
            get { return ((SPWorkflowActivationProperties)base.GetValue(WorkflowPropertiesProperty)); }
            set { base.SetValue(WorkflowPropertiesProperty, value); }
        }

        public static DependencyProperty MethodInvokedEvent =
            DependencyProperty.Register("MethodInvoked", typeof(EventHandler), typeof(OnItemChangedActivity));

        public event EventHandler MethodInvoking
        {
            add { base.AddHandler(MethodInvokedEvent, value); }
            remove { base.RemoveHandler(MethodInvokedEvent, value); }
        }
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.CategoryAttribute("Parameters")]
        public Guid SubscriptionId
        {
            get
            {
                return ((System.Guid)(base.GetValue(OnItemChangedActivity.SubscriptionIdProperty)));
            }
            set
            {
                base.SetValue(OnItemChangedActivity.SubscriptionIdProperty, value);
            }
        }

        [System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.CategoryAttribute("Parameters")]
        public int ItemId
        {
            get
            {
                return ((int)(base.GetValue(OnItemChangedActivity.ItemIdProperty)));
            }
            set
            {
                base.SetValue(OnItemChangedActivity.ItemIdProperty, value);
            }
        }

        [System.ComponentModel.DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.CategoryAttribute("Parameters")]
        public Guid ListId
        {
            get
            {
                return ((System.Guid)(base.GetValue(OnItemChangedActivity.ListIdProperty)));
            }
            set
            {
                base.SetValue(OnItemChangedActivity.ListIdProperty, value);
            }
        }

        private void OnItemChanged_Invoked(object sender, ExternalDataEventArgs e)
        {
            base.RaiseEvent(MethodInvokedEvent, this, EventArgs.Empty);
        }
        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            if (WorkflowProperties != null)
            {
                ItemId = WorkflowProperties.ItemId;
                ListId = WorkflowProperties.ListId;
            }

            if (SubscriptionId == Guid.Empty)
                SubscriptionId = Guid.NewGuid();
            ActivityExecutionStatus status = base.Execute(executionContext);

            return status;
        }

    }
}
